{
Ejempo de programas instalador usando WMI
=========================
By Germn Estvez (Neftal).
German_ral@hotmail.com

http://neftali.clubdelphi.com
http://neftali-mirror.site11.com/
}

unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Grids;

type
  TFormMain = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    sgProcesos: TStringGrid;
    mmInfo: TMemo;
    StatusBar1: TStatusBar;
    pnlInfo: TPanel;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
  private
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

// Constantes WMI
const
  STR_LOCALHOST = '.';
  STR_CIM2_ROOT = 'root\cimv2';

// Otras
const
  STR_EMPTY = '';
  CHAR_EQUAL = '=';


implementation

{$R *.dfm}

uses
  ShellAPI, ActiveX, WbemScripting_TLB, StrUtils;



procedure TFormMain.Button1Click(Sender: TObject);
var
  aServices:ISWbemServices;
  TS:TStrings;
  b:Boolean;
  Locator:ISWbemLocator;
  i, index, actual:Integer;
  str:string;

  //============================================================================
  procedure GetWMIProperties(AIndex:integer; {0-TODOS    1-Primero  2-segundo  3...}
                             Services:ISWbemServices; wmiClass:string;
                             var aProperties:TStrings);
  var
    SObject:  ISWbemObject;
    ObjSet:   ISWbemObjectSet;
    Enum:     IEnumVariant;
    TempObj:  OleVariant;
    Value:    Cardinal;
    i:        integer;
  begin

    // proteccion a problemas
    try

      // realizar la consulta
      ObjSet := Services.ExecQuery('SELECT * FROM '+wmiClass, 'WQL',
        wbemFlagReturnImmediately and wbemFlagForwardOnly , nil);
      // Lista de objetos
      Enum := (ObjSet._NewEnum) as IEnumVariant;

      i := 1;

      // Recorrer la lista
      while (Enum.Next(1, TempObj, Value) = S_OK) do begin

        // Todos o el que coincide con el ndice?
        if (AIndex = 0) or (AIndex = i) then begin
          // Access al objeto
          try
            SObject := IUnknown(TempObj) as ISWBemObject;
          except
            SObject := nil;
          end;

          // Encontrado?
          if (SObject <> nil) then begin
            // Acceder a la propiedad
            SObject.Properties_;
            aProperties.Add(SObject.GetObjectText_(0));
          end;

          // Slo se quiere 1?
          if (AIndex = i) then begin
            Break;
          end;
        end;

        // Siguiente
        Inc(i);
      end;
    finally
      // Nada (pendiente)
    end;
  end;
  //============================================================================
  function _ExtractValue(Data:string):string;
  var
    str:string;
    index:integer;
  begin
    Result := '';
    // Cadena
    Str := Trim(mmInfo.Lines[i]);
    index := AnsiPos(Data + ' = ', Str);
    if (index <> 0) then begin
      Str := Copy(Str, index + Length(Data + ' = ') + 1, Length(Str));
      Str := AnsiReplaceText(Str, '";', '');
      Result := Str;
    end;
  end;
  //============================================================================
begin

  pnlInfo.Visible := True;
  Application.ProcessMessages;

  try
    // Create the Location object
    Locator := CoSWbemLocator.Create();
    // Connect to the WMI service, with the root\cimv2 namespace
    aServices := Locator.ConnectServer(STR_EMPTY,
        STR_CIM2_ROOT, {user}STR_EMPTY, {password}STR_EMPTY,
        STR_EMPTY,STR_EMPTY, 0, nil);
    // continuar
  except
    MessageDlg('Error en la conexin', mtError, [mbOK], 0);
    Exit;
  end;

  TS := TStringList.Create();
  try
    GetWMIProperties(0, aServices, 'Win32_Product', TS);
    mmInfo.Lines.Text := TS.Text;

    for i := 0 to (mmInfo.Lines.Count - 1) do begin
      Application.ProcessMessages;

      // Caption
      Str := _ExtractValue('Caption');
      if (Str <> '') then begin
        actual := sgProcesos.RowCount;
        sgProcesos.Cells[0, actual-1] := Str;
        sgProcesos.RowCount := sgProcesos.RowCount + 1;
      end;

      // Install Date
      Str := _ExtractValue('InstallDate');
      if (Str <> '') then begin
        // formatear
        Str := Copy(Str, 7, 2) + '/' + Copy(Str, 5, 2) + '/' + Copy(Str, 1, 4);
        // Aadir
        sgProcesos.Cells[1, actual-1] := Str;
      end;

      // Vendor
      Str := _ExtractValue('Vendor');
      if (Str <> '') then begin
        sgProcesos.Cells[2, actual-1] := Str;
      end;

      // Version
      Str := _ExtractValue('Version');
      if (Str <> '') then begin
        sgProcesos.Cells[3, actual-1] := Str;
      end;

      Application.ProcessMessages
    end;

  finally
    pnlInfo.Visible := False;
    Application.ProcessMessages;

    FreeAndNil(TS);
  end;

//    lblProcesos.ItemIndex := 0;

end;

procedure TFormMain.StatusBar1Click(Sender: TObject);
begin
  // Abrir la WEB
    ShellExecute(Handle,
             'open',
             'http://neftali.clubdelphi.com',
             nil,
             nil,
             SW_SHOW);
    // Mirror
    ShellExecute(Handle,
             'open',
             'http://neftali-mirror.site11.com/',
             nil,
             nil,
             SW_SHOW);
end;

end.
